import type { Metadata } from 'next';
import { UserStoreProvider } from '@/stores/user/provider';
import Header from '@/eastar-common/design-system/Header/Header';

import './globals.css';
import '../assets/font.css';
import { getData1, getData2, getData3 } from '@/apis/api';
import { cookies, headers } from 'next/headers';
import Script from 'next/script';
import Version from '@/features/Version';

export const metadata: Metadata = {
    title: 'Create Next App',
    description: 'Generated by create next app'
};

export default async function RootLayout({
    children
}: Readonly<{
    children: React.ReactNode;
}>) {
    // const cookie = cookies().toString();
    // const token = await getToken(cookie ?? '');
    const d1 = await getData1();
    const d2 = await getData2();
    const d3 = await getData3();
    const cookieStore = cookies();

    // console.log(cookieStore.get('selected_country_code'));
    const name = `${d1?.unixtime},${d2?.unixtime},${d3?.unixtime}`;
    const data = { id: 'thepolaris87', name, lang: (cookieStore.get('selected_country_code')?.value as 'us' | 'kr') ?? 'us' } as const;
    const nonce = headers().get('x-nonce') ?? '';
    console.log('nonce', nonce);
    console.log('SERVER_ENV', process.env.SERVER_ENV);
    return (
        <html lang="ko">
            <Script
                id="j1"
                nonce={nonce}
                strategy="afterInteractive"
                dangerouslySetInnerHTML={{
                    __html: `
                    (function(j,ennifer) {
                        j['dmndata']=[];j['jenniferFront']=function(args){window.dmndata.push(args)};
                        j['dmnaid']=ennifer;j['dmnatime']=new Date();j['dmnanocookie']=false;j['dmnajennifer']='JENNIFER_FRONT@INTG';
                    }(window, 'a046e81c'));
                    `
                }}
            ></Script>
            <Script nonce={nonce} id="j2" strategy="afterInteractive" src="https://d-collect.jennifersoft.com/a046e81c/demian.js"></Script>
            <Script
                id="netfunnel123"
                strategy="lazyOnload"
                nonce={nonce}
                dangerouslySetInnerHTML={{
                    __html: `
                    (function(w,d,s,uri,fn){
                    w[fn] = w[fn] || function(){ var c = {}; c.tenantApiUrl = arguments[0]; c.tenantNFUrl = arguments[1]; c.tenantLoaderPort = arguments[2]; (w[fn].l = w[fn].l || []).push(c); };
                    var o = d.createElement(s); var p = d.getElementsByTagName(s)[0]; o.async = 1; o.charset = 'utf-8'; o.src = uri; p.parentNode.insertBefore(o,p);
                    })(window,document,'script','https://agent-lib.stclab.com/netfunnel-agent_latest.js','nfTag');
                    nfTag('https://nf-setting-bucket.stclab.com/jinbeo-7917.netfunnel/nf-setting.json', 'https://jinbeo-7917.netfunnel.stclab.com', '443');      
                    `
                }}
            ></Script>
            <UserStoreProvider data={data}>
                <body>
                    <Header />
                    {children}
                    <footer>Footer</footer>
                    <Version />
                </body>
            </UserStoreProvider>
        </html>
    );
}
